﻿// CodeGear C++Builder
// Copyright (c) 1995, 2022 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'IKFilterCore.pas' rev: 35.00 (Windows)

#ifndef IkfiltercoreHPP
#define IkfiltercoreHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <Winapi.Windows.hpp>
#include <Winapi.Messages.hpp>
#include <System.Classes.hpp>
#include <System.Math.hpp>
#include <System.SysUtils.hpp>
#include <IKTypes.hpp>
#include <IKRender.hpp>
#include <IKImage.hpp>

//-- user supplied -----------------------------------------------------------

namespace Ikfiltercore
{
//-- forward type declarations -----------------------------------------------
class DELPHICLASS TIKCropFilter;
class DELPHICLASS TIKAffineTransformFilter;
class DELPHICLASS TIKAffineClampFilter;
class DELPHICLASS TIKRotationFilter;
class DELPHICLASS TIKCustomGaussionFilter;
class DELPHICLASS TIKGaussianHFilter;
class DELPHICLASS TIKGaussianVFilter;
class DELPHICLASS TIKGaussianBlurFilter;
class DELPHICLASS TIKGaussianBlurClampFilter;
//-- type declarations -------------------------------------------------------
#pragma pack(push,4)
class PASCALIMPLEMENTATION TIKCropFilter : public Ikimage::TIKFilter
{
	typedef Ikimage::TIKFilter inherited;
	
private:
	Iktypes::TIKProgram* FKernel;
	Iktypes::TIKRect FInputRect;
	Ikimage::TIKImage* FInputImage;
	void __fastcall SetInputImage(Ikimage::TIKImage* const Value);
	void __fastcall SetInputRect(const Iktypes::TIKRect &Value);
	
protected:
	virtual Ikimage::TIKImage* __fastcall GetOutputImage();
	__classmethod virtual System::UnicodeString __fastcall GetCategoty();
	
public:
	__fastcall virtual TIKCropFilter();
	virtual void __fastcall Defaults();
	__property Iktypes::TIKRect InputRect = {read=FInputRect, write=SetInputRect};
	
__published:
	__property Ikimage::TIKImage* InputImage = {read=FInputImage, write=SetInputImage};
public:
	/* TIKFilter.Destroy */ inline __fastcall virtual ~TIKCropFilter() { }
	
};

#pragma pack(pop)

#pragma pack(push,4)
class PASCALIMPLEMENTATION TIKAffineTransformFilter : public Ikimage::TIKFilter
{
	typedef Ikimage::TIKFilter inherited;
	
private:
	Ikimage::TIKImage* FInputImage;
	Iktypes::TIKProgram* FKernel;
	Iktypes::TIKPoint FInflateLeftTop;
	Iktypes::TIKPoint FInflateRightBottom;
	Iktypes::TIKRect FOutputExtent;
	Iktypes::TIKMatrix FInputTransform;
	void __fastcall Callback(Iktypes::TIKProgram* const Kernel, const Ikimage::TIKKernelAction Action);
	Iktypes::TIKMatrix __fastcall OutputMatrix();
	Iktypes::TIKMatrix __fastcall KernelMatrix();
	
protected:
	virtual Ikimage::TIKImage* __fastcall GetOutputImage();
	__classmethod virtual System::UnicodeString __fastcall GetCategoty();
	
public:
	__fastcall virtual TIKAffineTransformFilter();
	virtual void __fastcall Defaults();
	
__published:
	__property Ikimage::TIKImage* InputImage = {read=FInputImage, write=FInputImage};
	
public:
	__property Iktypes::TIKMatrix InputTransform = {read=FInputTransform, write=FInputTransform};
public:
	/* TIKFilter.Destroy */ inline __fastcall virtual ~TIKAffineTransformFilter() { }
	
};

#pragma pack(pop)

#pragma pack(push,4)
class PASCALIMPLEMENTATION TIKAffineClampFilter : public TIKAffineTransformFilter
{
	typedef TIKAffineTransformFilter inherited;
	
private:
	Iktypes::TIKRect FInputRect;
	HIDESBASE void __fastcall DoSetValue(const System::UnicodeString Name, const Iktypes::TIKValue &Value);
	
protected:
	virtual Ikimage::TIKImage* __fastcall GetOutputImage();
	__classmethod virtual System::UnicodeString __fastcall GetCategoty();
	
public:
	__fastcall virtual TIKAffineClampFilter();
	virtual void __fastcall Defaults();
	__property Iktypes::TIKRect InputRect = {read=FInputRect, write=FInputRect};
public:
	/* TIKFilter.Destroy */ inline __fastcall virtual ~TIKAffineClampFilter() { }
	
};

#pragma pack(pop)

#pragma pack(push,4)
class PASCALIMPLEMENTATION TIKRotationFilter : public Ikimage::TIKFilter
{
	typedef Ikimage::TIKFilter inherited;
	
private:
	TIKAffineTransformFilter* FAffineFilter;
	float FInputAngle;
	float FInputAngleMin;
	float FInputAngleMax;
	Ikimage::TIKImage* FInputImage;
	
protected:
	virtual Ikimage::TIKImage* __fastcall GetOutputImage();
	__classmethod virtual System::UnicodeString __fastcall GetCategoty();
	
public:
	__fastcall virtual TIKRotationFilter();
	__fastcall virtual ~TIKRotationFilter();
	virtual void __fastcall Defaults();
	
__published:
	__property float InputAngle = {read=FInputAngle, write=FInputAngle};
	__property float InputAngle_Min = {read=FInputAngleMin};
	__property float InputAngle_Max = {read=FInputAngleMax};
	__property Ikimage::TIKImage* InputImage = {read=FInputImage, write=FInputImage};
};

#pragma pack(pop)

#pragma pack(push,4)
class PASCALIMPLEMENTATION TIKCustomGaussionFilter : public Ikimage::TIKFilter
{
	typedef Ikimage::TIKFilter inherited;
	
private:
	Ikimage::TIKImage* FInputImage;
	Iktypes::TIKProgram* FKernel;
	float FInputRadius;
	bool FClamp;
	
protected:
	void __fastcall Callback(Iktypes::TIKProgram* const Kernel, const Ikimage::TIKKernelAction Action);
	
__published:
	__property Ikimage::TIKImage* InputImage = {read=FInputImage, write=FInputImage};
	__property float InputRadius = {read=FInputRadius, write=FInputRadius};
public:
	/* TIKFilter.Create */ inline __fastcall virtual TIKCustomGaussionFilter() : Ikimage::TIKFilter() { }
	/* TIKFilter.Destroy */ inline __fastcall virtual ~TIKCustomGaussionFilter() { }
	
};

#pragma pack(pop)

#pragma pack(push,4)
class PASCALIMPLEMENTATION TIKGaussianHFilter : public TIKCustomGaussionFilter
{
	typedef TIKCustomGaussionFilter inherited;
	
protected:
	virtual Ikimage::TIKImage* __fastcall GetOutputImage();
	
public:
	__fastcall virtual TIKGaussianHFilter();
public:
	/* TIKFilter.Destroy */ inline __fastcall virtual ~TIKGaussianHFilter() { }
	
};

#pragma pack(pop)

#pragma pack(push,4)
class PASCALIMPLEMENTATION TIKGaussianVFilter : public TIKCustomGaussionFilter
{
	typedef TIKCustomGaussionFilter inherited;
	
protected:
	virtual Ikimage::TIKImage* __fastcall GetOutputImage();
	
public:
	__fastcall virtual TIKGaussianVFilter();
public:
	/* TIKFilter.Destroy */ inline __fastcall virtual ~TIKGaussianVFilter() { }
	
};

#pragma pack(pop)

#pragma pack(push,4)
class PASCALIMPLEMENTATION TIKGaussianBlurFilter : public Ikimage::TIKFilter
{
	typedef Ikimage::TIKFilter inherited;
	
private:
	TIKGaussianVFilter* FBlurV;
	TIKGaussianHFilter* FBlurH;
	Ikimage::TIKImage* FInputImage;
	float FInputRadius;
	float FInputRadiusMin;
	float FInputRadiusMax;
	void __fastcall SetInputImage(Ikimage::TIKImage* const Value);
	void __fastcall SetInputRadius(const float Value);
	
protected:
	virtual Ikimage::TIKImage* __fastcall GetOutputImage();
	virtual void __fastcall ValueChanged();
	__classmethod virtual System::UnicodeString __fastcall GetCategoty();
	
public:
	__fastcall virtual TIKGaussianBlurFilter();
	__fastcall virtual ~TIKGaussianBlurFilter();
	virtual void __fastcall Defaults();
	
__published:
	__property Ikimage::TIKImage* InputImage = {read=FInputImage, write=SetInputImage};
	__property float InputRadius = {read=FInputRadius, write=SetInputRadius};
	__property float InputRadius_Min = {read=FInputRadiusMin};
	__property float InputRadius_Max = {read=FInputRadiusMax};
};

#pragma pack(pop)

#pragma pack(push,4)
class PASCALIMPLEMENTATION TIKGaussianBlurClampFilter : public Ikimage::TIKFilter
{
	typedef Ikimage::TIKFilter inherited;
	
private:
	TIKGaussianVFilter* FBlurV;
	TIKGaussianHFilter* FBlurH;
	Ikimage::TIKImage* FInputImage;
	float FInputRadius;
	float FInputRadiusMin;
	float FInputRadiusMax;
	void __fastcall SetInputImage(Ikimage::TIKImage* const Value);
	void __fastcall SetInputRadius(const float Value);
	
protected:
	virtual Ikimage::TIKImage* __fastcall GetOutputImage();
	virtual void __fastcall ValueChanged();
	__classmethod virtual System::UnicodeString __fastcall GetCategoty();
	
public:
	__fastcall virtual TIKGaussianBlurClampFilter();
	__fastcall virtual ~TIKGaussianBlurClampFilter();
	virtual void __fastcall Defaults();
	
__published:
	__property Ikimage::TIKImage* InputImage = {read=FInputImage, write=SetInputImage};
	__property float InputRadius = {read=FInputRadius, write=SetInputRadius};
	__property float InputRadius_Min = {read=FInputRadiusMin};
	__property float InputRadius_Max = {read=FInputRadiusMax};
};

#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------
}	/* namespace Ikfiltercore */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_IKFILTERCORE)
using namespace Ikfiltercore;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// IkfiltercoreHPP
