﻿// CodeGear C++Builder
// Copyright (c) 1995, 2024 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'IKImageView.pas' rev: 36.00 (Windows)

#ifndef IkimageviewHPP
#define IkimageviewHPP

#pragma delphiheader begin
#pragma option push
#if defined(__BORLANDC__) && !defined(__clang__)
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#endif
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <Winapi.Windows.hpp>
#include <Winapi.Messages.hpp>
#include <System.Classes.hpp>
#include <System.Math.hpp>
#include <System.SysUtils.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.Graphics.hpp>
#include <Vcl.Imaging.pngimage.hpp>
#include <IKTypes.hpp>
#include <IKRender.hpp>
#include <IKImage.hpp>
#include <IKLayer.hpp>
#include <IKLayerView.hpp>
#include <IKAnimation.hpp>
#include <System.UITypes.hpp>
#include <Vcl.BaseImageCollection.hpp>
#include <Vcl.ImageCollection.hpp>
#include <IKDXView.hpp>

//-- user supplied -----------------------------------------------------------

namespace Ikimageview
{
//-- forward type declarations -----------------------------------------------
class DELPHICLASS TIKImageView;
//-- type declarations -------------------------------------------------------
enum DECLSPEC_DENUM TIKBackgroundMode : unsigned int { bmSolidColor, bmCheckerboard };

class PASCALIMPLEMENTATION TIKImageView : public Iklayerview::TIKLayerView
{
	typedef Iklayerview::TIKLayerView inherited;
	
private:
	Vcl::Graphics::TPicture* FPicture;
	Ikimage::TIKImage* FImage;
	Iklayer::TIKLayer* FImageOwner;
	Iklayer::TIKLayer* FImageLayer;
	TIKBackgroundMode FBackgroundMode;
	bool FAnimatable;
	float FScale;
	bool FImageCollectionScaled;
	Vcl::Baseimagecollection::TCustomImageCollection* FImageCollection;
	int FImageCollectionWidth;
	int FImageCollectionHeight;
	int FImageIndex;
	bool FImageCollectionProportional;
	void __fastcall SetImageCollectionProportional(bool Value);
	void __fastcall SetImageCollection(Vcl::Baseimagecollection::TCustomImageCollection* Value);
	void __fastcall SetImageIndex(const int Value);
	void __fastcall SetImageCollectionWidth(int Value);
	void __fastcall SetImageCollectionHeight(int Value);
	void __fastcall SetPicture(Vcl::Graphics::TPicture* const Value);
	void __fastcall SetContentMode(const Iklayer::TIKContentMode Value);
	void __fastcall SetBackgroundMode(const TIKBackgroundMode Value);
	void __fastcall SetRotationAngle(const float Value);
	void __fastcall SetOpacity(const float Value);
	void __fastcall SetYRotationAngle(const float Value);
	void __fastcall SetXRotationAngle(const float Value);
	Ikimage::TIKFilter* __fastcall GetContentFilter();
	void __fastcall SetContentFilter(Ikimage::TIKFilter* const Value);
	Iktypes::TIKColorF __fastcall GetShadowColor();
	Iktypes::TIKPoint __fastcall GetShadowOffset();
	float __fastcall GetShadowRadius();
	void __fastcall SetShadowColor(const Iktypes::TIKColorF &Value);
	void __fastcall SetShadowOffset(const Iktypes::TIKPoint &Value);
	void __fastcall SetShadowRadius(const float Value);
	bool __fastcall GetShowShadow();
	void __fastcall SetShowShadow(const bool Value);
	void __fastcall UpdateBackgroundMode();
	float __fastcall GetXRotationAngle();
	void __fastcall SetScale(const float Value);
	float __fastcall GetRotationAngle();
	float __fastcall GetYRotationAngle();
	float __fastcall GetOpacity();
	Iklayer::TIKContentMode __fastcall GetContentMode();
	
protected:
	virtual void __fastcall Notification(System::Classes::TComponent* AComponent, System::Classes::TOperation Operation);
	DYNAMIC void __fastcall ChangeScale(int M, int D, bool isDpiChange)/* overload */;
	virtual void __fastcall DoLayout();
	void __fastcall DoChange(System::TObject* Sender);
	bool __fastcall IsAnimatable();
	
public:
	__fastcall virtual TIKImageView(System::Classes::TComponent* AOwner);
	__fastcall virtual ~TIKImageView();
	virtual void __fastcall Loaded();
	Vcl::Graphics::TBitmap* __fastcall GrabToBitmap();
	Vcl::Imaging::Pngimage::TPngImage* __fastcall GrabToPngImage();
	__property Iklayer::TIKLayer* ImageLayer = {read=FImageLayer};
	
__published:
	__property bool ImageCollectionScaled = {read=FImageCollectionScaled, write=FImageCollectionScaled, default=1};
	__property Vcl::Baseimagecollection::TCustomImageCollection* ImageCollection = {read=FImageCollection, write=SetImageCollection};
	__property bool ImageCollecitonProportional = {read=FImageCollectionProportional, write=SetImageCollectionProportional, default=1};
	__property int ImageCollecitonWidth = {read=FImageCollectionWidth, write=SetImageCollectionWidth, nodefault};
	__property int ImageCollecitonHeight = {read=FImageCollectionHeight, write=SetImageCollectionHeight, nodefault};
	__property int ImageIndex = {read=FImageIndex, write=SetImageIndex, default=-1};
	__property bool Animatable = {read=FAnimatable, write=FAnimatable, nodefault};
	__property TIKBackgroundMode BackgroundMode = {read=FBackgroundMode, write=SetBackgroundMode, nodefault};
	__property Iklayer::TIKContentMode ContentMode = {read=GetContentMode, write=SetContentMode, nodefault};
	__property Ikimage::TIKFilter* ContentFilter = {read=GetContentFilter, write=SetContentFilter};
	__property float RotationAngle = {read=GetRotationAngle, write=SetRotationAngle};
	__property float XRotationAngle = {read=GetXRotationAngle, write=SetXRotationAngle};
	__property float YRotationAngle = {read=GetYRotationAngle, write=SetYRotationAngle};
	__property Vcl::Graphics::TPicture* Picture = {read=FPicture, write=SetPicture};
	__property float Scale = {read=FScale, write=SetScale};
	
public:
	__property Iktypes::TIKColorF ShadowColor = {read=GetShadowColor, write=SetShadowColor};
	
__published:
	__property float ShadowRadius = {read=GetShadowRadius, write=SetShadowRadius};
	
public:
	__property Iktypes::TIKPoint ShadowOffset = {read=GetShadowOffset, write=SetShadowOffset};
	
__published:
	__property bool ShowShadow = {read=GetShowShadow, write=SetShowShadow, nodefault};
	__property float Opacity = {read=GetOpacity, write=SetOpacity};
public:
	/* TWinControl.CreateParented */ inline __fastcall TIKImageView(HWND ParentWindow) : Iklayerview::TIKLayerView(ParentWindow) { }
	
	/* Hoisted overloads: */
	
protected:
	DYNAMIC inline void __fastcall  ChangeScale(int M, int D){ Vcl::Controls::TControl::ChangeScale(M, D); }
	
};


//-- var, const, procedure ---------------------------------------------------
}	/* namespace Ikimageview */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_IKIMAGEVIEW)
using namespace Ikimageview;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// IkimageviewHPP
