﻿// CodeGear C++Builder
// Copyright (c) 1995, 2017 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'IKAnimation.pas' rev: 32.00 (Windows)

#ifndef IkanimationHPP
#define IkanimationHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <Winapi.Windows.hpp>
#include <Winapi.Messages.hpp>
#include <System.Classes.hpp>
#include <System.Math.hpp>
#include <System.SysUtils.hpp>
#include <Vcl.Graphics.hpp>
#include <System.TypInfo.hpp>
#include <IKTypes.hpp>

//-- user supplied -----------------------------------------------------------

namespace Ikanimation
{
//-- forward type declarations -----------------------------------------------
struct TIKTimingFunction;
class DELPHICLASS EIKAnimationException;
class DELPHICLASS TIKAnimationDictionary;
class DELPHICLASS TIKTransaction;
class DELPHICLASS TIKAnimation;
class DELPHICLASS TIKPropertyAnimation;
//-- type declarations -------------------------------------------------------
enum DECLSPEC_DENUM TIKTimingFunctionKind : unsigned int { fkCubicBezier, fkSteps };

struct DECLSPEC_DRECORD TIKTimingFunction
{
public:
	TIKTimingFunctionKind Kind;
	
public:
	union
	{
		struct 
		{
			Iktypes::TIKPoint FirstPoint;
			Iktypes::TIKPoint SecondPoint;
		};
		struct 
		{
			int Steps;
			bool Ceil;
		};
		
	};
};


#pragma pack(push,4)
class PASCALIMPLEMENTATION EIKAnimationException : public System::Sysutils::Exception
{
	typedef System::Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ inline __fastcall EIKAnimationException(const System::UnicodeString Msg) : System::Sysutils::Exception(Msg) { }
	/* Exception.CreateFmt */ inline __fastcall EIKAnimationException(const System::UnicodeString Msg, const System::TVarRec *Args, const int Args_High) : System::Sysutils::Exception(Msg, Args, Args_High) { }
	/* Exception.CreateRes */ inline __fastcall EIKAnimationException(NativeUInt Ident)/* overload */ : System::Sysutils::Exception(Ident) { }
	/* Exception.CreateRes */ inline __fastcall EIKAnimationException(System::PResStringRec ResStringRec)/* overload */ : System::Sysutils::Exception(ResStringRec) { }
	/* Exception.CreateResFmt */ inline __fastcall EIKAnimationException(NativeUInt Ident, const System::TVarRec *Args, const int Args_High)/* overload */ : System::Sysutils::Exception(Ident, Args, Args_High) { }
	/* Exception.CreateResFmt */ inline __fastcall EIKAnimationException(System::PResStringRec ResStringRec, const System::TVarRec *Args, const int Args_High)/* overload */ : System::Sysutils::Exception(ResStringRec, Args, Args_High) { }
	/* Exception.CreateHelp */ inline __fastcall EIKAnimationException(const System::UnicodeString Msg, int AHelpContext) : System::Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ inline __fastcall EIKAnimationException(const System::UnicodeString Msg, const System::TVarRec *Args, const int Args_High, int AHelpContext) : System::Sysutils::Exception(Msg, Args, Args_High, AHelpContext) { }
	/* Exception.CreateResHelp */ inline __fastcall EIKAnimationException(NativeUInt Ident, int AHelpContext)/* overload */ : System::Sysutils::Exception(Ident, AHelpContext) { }
	/* Exception.CreateResHelp */ inline __fastcall EIKAnimationException(System::PResStringRec ResStringRec, int AHelpContext)/* overload */ : System::Sysutils::Exception(ResStringRec, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ inline __fastcall EIKAnimationException(System::PResStringRec ResStringRec, const System::TVarRec *Args, const int Args_High, int AHelpContext)/* overload */ : System::Sysutils::Exception(ResStringRec, Args, Args_High, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ inline __fastcall EIKAnimationException(NativeUInt Ident, const System::TVarRec *Args, const int Args_High, int AHelpContext)/* overload */ : System::Sysutils::Exception(Ident, Args, Args_High, AHelpContext) { }
	/* Exception.Destroy */ inline __fastcall virtual ~EIKAnimationException(void) { }
	
};

#pragma pack(pop)

class PASCALIMPLEMENTATION TIKAnimationDictionary : public Iktypes::TIKObjectDictionary
{
	typedef Iktypes::TIKObjectDictionary inherited;
	
public:
	HIDESBASE bool __fastcall TryGetValue(const System::UnicodeString Key, TIKAnimation* &Value);
public:
	/* TIKObjectDictionary.Create */ inline __fastcall TIKAnimationDictionary(bool Owned) : Iktypes::TIKObjectDictionary(Owned) { }
	/* TIKObjectDictionary.Destroy */ inline __fastcall virtual ~TIKAnimationDictionary(void) { }
	
};


typedef void __fastcall (__closure *TAnimationProcess)(System::TObject* Sender, const double NormalizedTime);

#pragma pack(push,4)
class PASCALIMPLEMENTATION TIKTransaction : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	float FDuration;
	TIKTimingFunction FTimingFunction;
	float FDelay;
	int FRepeatCount;
	bool FEnabled;
	__classmethod TIKTransaction* __fastcall Default();
	__classmethod bool __fastcall IsUpdating();
	
protected:
	__classmethod void __fastcall DestroyList();
	__fastcall TIKTransaction(void);
	
public:
	__classmethod void __fastcall BeginUpdate(const bool Enabled = true);
	__classmethod void __fastcall EndUpdate();
	__classmethod void __fastcall SetDelay(const float Value);
	__classmethod void __fastcall SetDuration(const float Value);
	__classmethod void __fastcall SetTimingFunction(const TIKTimingFunction &Value);
	__classmethod void __fastcall SetRepeatCount(const int Value);
	__classmethod void __fastcall Disable();
	__classmethod void __fastcall Enable();
	__classmethod TIKTransaction* __fastcall Current();
	__property float Duration = {read=FDuration, write=FDuration};
	__property float Delay = {read=FDelay, write=FDelay};
	__property bool Enabled = {read=FEnabled, write=FEnabled, nodefault};
	__property int RepeatCount = {read=FRepeatCount, write=FRepeatCount, nodefault};
	__property TIKTimingFunction TimingFunction = {read=FTimingFunction, write=FTimingFunction};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TIKTransaction(void) { }
	
};

#pragma pack(pop)

class PASCALIMPLEMENTATION TIKAnimation : public System::Classes::TPersistent
{
	typedef System::Classes::TPersistent inherited;
	
private:
	double FDuration;
	System::Classes::TNotifyEvent FOnFinish;
	System::Classes::TNotifyEvent FOnStart;
	double FDelay;
	TAnimationProcess FOnProcess;
	bool FFreeOnFinished;
	TIKTimingFunction FTimingFunction;
	int FRepeatCount;
	System::Sysutils::_di_TProc FOnFinishProc;
	void __fastcall SetDuration(const double Value);
	void __fastcall SetDelay(const double Value);
	
protected:
	virtual void __fastcall DoProcess(const double NormalizedTime);
	virtual void __fastcall DoFinish(void);
	virtual void __fastcall DoStart(void);
	
public:
	__fastcall TIKAnimation(const System::Sysutils::_di_TProc FinishProc);
	__fastcall virtual ~TIKAnimation(void);
	void __fastcall Start(void);
	void __fastcall Stop(void);
	__property bool FreeOnFinished = {read=FFreeOnFinished, write=FFreeOnFinished, nodefault};
	__property double Delay = {read=FDelay, write=SetDelay};
	__property double Duration = {read=FDuration, write=SetDuration};
	__property TIKTimingFunction TimingFunction = {read=FTimingFunction, write=FTimingFunction};
	__property int RepeatCount = {read=FRepeatCount, write=FRepeatCount, nodefault};
	__property System::Classes::TNotifyEvent OnStart = {read=FOnStart, write=FOnStart};
	__property System::Classes::TNotifyEvent OnFinish = {read=FOnFinish, write=FOnFinish};
	__property System::Sysutils::_di_TProc OnFinishProc = {read=FOnFinishProc, write=FOnFinishProc};
	__property TAnimationProcess OnProcess = {read=FOnProcess, write=FOnProcess};
};


class PASCALIMPLEMENTATION TIKPropertyAnimation : public TIKAnimation
{
	typedef TIKAnimation inherited;
	
private:
	System::UnicodeString FPropertyName;
	System::TObject* FTarget;
	Iktypes::TIKValue FToValue;
	Iktypes::TIKValue FFromValue;
	void __fastcall SetTarget(System::TObject* const Value);
	void __fastcall SetFromValue(const Iktypes::TIKValue &Value);
	void __fastcall SetToValue(const Iktypes::TIKValue &Value);
	
protected:
	virtual void __fastcall DoStart(void);
	virtual void __fastcall DoProcess(const double NormalizedTime);
	
public:
	__fastcall TIKPropertyAnimation(System::TObject* const ATarget, const System::UnicodeString APropertyName, const Iktypes::TIKValue &AToValue, const System::Sysutils::_di_TProc FinishProc);
	__property System::TObject* Target = {read=FTarget, write=SetTarget};
	__property System::UnicodeString PropertyName = {read=FPropertyName, write=FPropertyName};
	__property Iktypes::TIKValue FromValue = {read=FFromValue, write=SetFromValue};
	__property Iktypes::TIKValue ToValue = {read=FToValue, write=SetToValue};
public:
	/* TIKAnimation.Destroy */ inline __fastcall virtual ~TIKPropertyAnimation(void) { }
	
};


//-- var, const, procedure ---------------------------------------------------
#define IKDefaultDuration  (2.500000E-01)
extern DELPHI_PACKAGE TIKTimingFunction DefaultTimingFunc;
extern DELPHI_PACKAGE TIKTimingFunction LinearTimingFunc;
extern DELPHI_PACKAGE TIKTimingFunction EaseTimingFunc;
extern DELPHI_PACKAGE TIKTimingFunction EaseInTimingFunc;
extern DELPHI_PACKAGE TIKTimingFunction EaseOutTimingFunc;
extern DELPHI_PACKAGE TIKTimingFunction EaseInOutTimingFunc;
extern DELPHI_PACKAGE TIKTimingFunction __fastcall TimingFunction(const Iktypes::TIKPoint &FirstPoint, const Iktypes::TIKPoint &SecondPoint)/* overload */;
extern DELPHI_PACKAGE TIKTimingFunction __fastcall TimingFunction(const int Steps, bool Ceil)/* overload */;
}	/* namespace Ikanimation */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_IKANIMATION)
using namespace Ikanimation;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// IkanimationHPP
